/*
 *  CLAMPTypes.h
 *  Originally created by Chip Jarred for David Pollock's CLAMP/PLEX program
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 This file includes all the data types in PLEX workspace
 commented by Wanjun
*/

#ifndef CLAMPTypes_h__
#define CLAMPTypes_h__

#define INCLUDE_UNUSED_FUNCTIONS	0

#include <string>
#include <vector>

#include "Matrix3D.h"
#include "Sequence.h"

using std::string;

typedef std::string			String;
typedef Matrix<String>			StringMatrix;
typedef Vector<double>			DoubleVector;
typedef Vector<long double>		LDoubleVector;
typedef Vector<int>			IntVector;
typedef std::vector<std::string>	StringVector;
//typedef std::vector<Sequence>		SequenceVector;
typedef std::vector<std::vector<int> > SequenceVector;
typedef std::vector<char>		CharVector;
typedef Matrix<double>			DoubleMatrix;
typedef Matrix<int>			IntMatrix;
typedef	Matrix3D<double>		DoubleMatrix3D;
typedef Matrix3D<int>			IntMatrix3D;

#endif // CLAMPTypes_h__
