/*
 *  Matrix3DLite.h
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

template <typename DataType>
class Matrix3DLite {
	public:
			
		int	fRows;
		int	fCols;
		int	fLayers;

			
		Matrix3DLite(void);
		int empty();
		
		Matrix3DLite(
			int			inRows,
			int			inColumns,
			int			inLayers,
			const DataType&		inValue = DataType());
		Matrix3DLite(
			const Matrix3DLite&		inMatrix);
virtual	~Matrix3DLite(void) {}

			
virtual	void							fill(
			const DataType&		inVal);

virtual	void							resize(
			int			inRows,
			int			inColumns,
			int			inLayers,
			const DataType&		inVal = DataType());
			
	private:
	DataType								*mRows;
};


//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(void)
{
}

//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(
	int		inRows,
	int		inColumns,
	int		inLayers,
	const DataType&	inValue)
{
	resize(inRows, inColumns, inLayers, inValue);
}

//---------------------------------------------------------------------------
template <typename DataType>
Matrix3DLite<DataType>::Matrix3DLite(
	const Matrix3DLite&	inMatrix)
{
}


//---------------------------------------------------------------------------
template <typename DataType>
void
Matrix3DLite<DataType>::fill(
	const DataType&	inVal)
{
	for (int i = 0; i < (fRows * fCols * fLayers); i++)
		mRows[i] = inVal;
}

//---------------------------------------------------------------------------
template <typename DataType>
int
Matrix3DLite<DataType>::empty(
	void)
{
	if ((fRows * fCols * fLayers) == 0) { return 1; } else { return 0; }
}
//---------------------------------------------------------------------------
template <typename DataType>
void
Matrix3DLite<DataType>::resize(
	int		inRows,
	int		inColumns,
	int		inLayers,
	const DataType&	inVal)
{
	delete [] mRows;
	mRows = new DataType[ (inLayers * inRows * inColumns) ];
	fRows= inRows; fCols = inColumns; fLayers = inLayers;
}

