/*
 *  NodeDistanceMaker.h
 *  Originally created by Chip Jarred for David Pollock's CLAMP/PLEX program
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NodeDistanceMaker_h__
#define NodeDistanceMaker_h__

#include "TreeParser.h"
#include "TreeNodeData.h"


#include <string>

class NodeDistanceMaker : public TreeParser::NodeMaker
{
	public:
		static	const std::string		cInitName;
		
		typedef	TreeNode	node_type;
		virtual							~NodeDistanceMaker(void);
		virtual	node_type*				Make(
											const std::string&	inNodeDescription,
											node_type*			inNodeToSetFromDescription = 0) const;
	private:
				double					GetInitDistance() const;
				const std::string&		GetInitName() const;
				
		static	unsigned int			sNumNodes;
};

#endif // NodeDistanceMaker_h__
