/*
 *  Sequence.h
 *  Originally created by Chip Jarred for David Pollock's CLAMP/PLEX program
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// OBSOLETE CLASS. STILL USED IN SOME OLD CODE; WILL BE FULLY PHASED OUT SOON.

#ifndef Sequence_h__
#define Sequence_h__

#include <string>

#include "macrodefine.h"

class Sequence_Impl;

class Sequence
{
	public:
		static const char					cEndSeq = ENDSEQ;
		static const char					cNewSeq = NEWSEQ;
		
		typedef unsigned int					size_type;
		
		// -----------------------------------------------------------------------------------------------
		// class SharedTransaction
		//
		// Use this class in order to alter all copies of a Sequence that share the same underlying data
		// simultaneously.
		class SharedTransaction
		{
			public:
							SharedTransaction(
								Sequence&	inSequence)
							:	mSequence(inSequence)
							{
								mSequence.BeginSharedChange();
							}
							
							~SharedTransaction(void)
							{
								mSequence.EndSharedChange();
							}
			private:
				Sequence&	mSequence;
		};
		// -----------------------------------------------------------------------------------------------
		
												Sequence(void);
												Sequence(
													const Sequence&		inSrc);
				explicit						Sequence(
													const std::string&	inSrc);
		virtual									~Sequence(void);
		
				const Sequence&					operator=(
													const Sequence&		inSrc);
				bool							operator==(
													const Sequence&		inSrc) const;
				bool							operator!=(
													const Sequence&		inSrc) const
												{
													return !operator==(inSrc);
												}
													
				const char						operator[](
													size_type			inIndex) const;
													
				void							resize(
													size_type			inNewSize);
				size_type						size(void) const;
				
												// This method gets the sequence len which is not necessarily the
												// the same as size().
				size_type						GetLen(void) const;
				
				void							clear();

				bool							empty() const;
				
				void							SetAtIndex(
													size_type			inIndex,
													char				inValue);

				void							push_back(
													char				inVal);

				std::string						str(void) const;
				
				void							SetString(const std::string& inString);
				
	//			void							Mix(
	//												std::vector<int>	inSeq1,
	//												std::vector< std::vector<int> >*	inSeq2);
													
				int							GetAssignment(void);
				
				void							SetAssignment(const int& inAssignment);
	
				Sequence_Impl*					mImpl;
				
	protected:
	private:
		friend	class SharedTransaction;
		
				void							Swap(
													Sequence&			ioSwapee);
				void							PrepareToModify(void);
				
												// These two methods are used to bracket when you want to disable
												// the copy-on-write semantics of this object so that all copies
												// will be changed.
				void							BeginSharedChange(void);
				void							EndSharedChange(void);
};
#endif // Sequence_h__
