/*
 *  SequenceAddressing.h Created by A.P. Jason de Koning on 9/25/08 for PLEX

 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

class Sequence;
class Sequence_Impl
{
	public:
		typedef unsigned int						RefCount;
		typedef unsigned int						size_type;
		
													Sequence_Impl(
														const std::string&			inSeqenceStr = "");
													Sequence_Impl(
														const Sequence_Impl&	inSrc);
													~Sequence_Impl(void);
													
				bool								IsShared(void) const;
				void								Retain(void) const;
				void								Release(void) const;
				
				void								resize(
														size_type				inNewSize);
				size_type							size(void) const;
				
				size_type							GetLen(void) const;
				
				void								SetAtIndex(
														size_type				inIndex,
														char					inVal);
				void								push_back(
														char					inVal);
														
	//			const std::string&						str(void) const;
				
				std::string							str(void) const;
				
				void								SetString(const std::string& inString);
				
				int								GetAssignment(void);
				
				void								SetAssignment(const int& inAssignment);
				
				void								Mix(
														Sequence*	inSeq);
				
				const char							operator[](
														size_type				inIndex) const;
				bool								operator==(
														const Sequence_Impl&	inSrc) const;
														
				void								BeginSharedChange(void);
				void								EndSharedChange(void);
				std::string							mSequenceStr;
	protected:
	private:
				mutable	RefCount						mRefCount;
				RefCount							mSharedChangeCount;
				int								mModelAssignment;
};

