//
//  SimplifiedLogL.cpp  Created for PLEXlite by A.P. Jason de Koning on   1/23/12.
/*
PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
version 0.94 - beta version July, 2012

Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
jason.de.koning@gmail.com http://jasondk.org
wanjungu@gmail.com
David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com

This program was created and distributed by the
David Pollock laboratory, University of Colorado School of Medicine
copyright © 2012 David Pollock
All rights reserved.

http://www.evolutionarygenomics.com
Dept. Biochemistry & Molecular Genetics
12801 17th Ave., MS 8101
PO Box 6511
Aurora, CO 80045

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include "Numerics.h"
#include "SimplifiedLogL.h"

// *****************************************************************************************************************************
//  Interface to callable partial likelihood functions that use the Numerics:: functions
// *****************************************************************************************************************************

SimplifiedLogL_individualRateParm::SimplifiedLogL_individualRateParm( void ) { }

SimplifiedLogL::SimplifiedLogL( void ) { }

SimplifiedLogL::SimplifiedLogL( int xInit, int yInit, double muInit, double C1init, double CXYinit, DoubleMatrix& rateMatrix ) {
    x = xInit;
    y = yInit;
    mu = muInit;
    C1 = C1init;
    CXY = CXYinit;
    rates = rateMatrix;
    
    num = &Numerics::getGlobalNumerics();
}

void SimplifiedLogL::setParms( int xInit, int yInit, double muInit, double C1init, double CXYinit, DoubleMatrix& rateMatrix ) {
    x = xInit;
    y = yInit;
    mu = muInit;
    C1 = C1init;
    CXY = CXYinit;
    rates = rateMatrix;
}

double SimplifiedLogL_individualRateParm::logL( double x1 )  {
    return num->b1u_likelihoodContribution_rateParameter( x1, rates.mRows.mDataArray[x].mDataArray[y], C1, CXY, mu);
}

