/*
 *  TreeNode.cpp
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "TreeNode.h"
#include "macrodefine.h"
#include "Sequence.h"
#include "CLAMPTypes.h"
#include "Numerics.h"
//#include "MixtureModel.h"

#include "Model.h"

#include <cassert>
#include <deque>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <string>

using std::ofstream;
using std::flush;
using std::setfill;
using std::setprecision;
using std::dec;
using std::fixed;
using std::hex;
using std::endl;
using std::ostringstream;
using std::min;
using std::cerr;
using std::setw;
using std::setprecision;

 class Tree;

/*
void threadFunction_ancestralStates(void *threadarg) {
	// Experimental: wrapper to allow use of pthreads (boost)
    
	struct thread_data *my_data;
	my_data = (struct thread_data *) threadarg;
	void (*callMe)(struct thread_data) = NULL;
	std::cout << "I am thread #" << my_data->thread_id << endl;
	callMe = (void(*))my_data->theFxn;
	(*callMe)(*my_data);
//	my_data->theFxn(my_data);
}

*/