/*
 * TreeNodeData.cpp
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version  July, 2012
 
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "TreeNodeData.h"

#include <algorithm>
#include <string.h>

using std::fill_n;


//---------------------------------------------------------------------------
TreeNodeData_::TreeNodeData_() {
	
    distance = cInitDistance;
    id =0;
    //		tips(0),
    sequence.clear();
    //		state(0),
    //		color(0),
    //		thickness(0),
    //		probto(0),
    //		likeleft(0),
    //		likeright(0),
    //		likeup(0),
    //		likechange(0),
    //		likenochange(0),
    
    //countchange.fill(0);
    //);
    //countModelchange3D();

	fill_n(&name[0], MAXNAME, '\0');
	siteLallocatedFlag = 0;
	doScaling = 0;
	branchLengthIndex = 0;
}


//---------------------------------------------------------------------------
TreeNodeData_::TreeNodeData_(
                             const TreeNodeData_& inSrc)
{
	strcpy(name, inSrc.name);
	distance = inSrc.distance;
	id = inSrc.id;
	sequence = inSrc.sequence;
	countchange = inSrc.countchange;
	probmatrix3D = inSrc.probmatrix3D;
	countModelchange3D = inSrc.countModelchange3D;
	siteLallocatedFlag = 0;
	doScaling = inSrc.doScaling;
}

//---------------------------------------------------------------------------
const TreeNodeData_&	TreeNodeData_::operator=(
                                                 const TreeNodeData_& inSrc)
{
	strcpy(name, inSrc.name);
	distance = inSrc.distance;
	id = inSrc.id;
	sequence = inSrc.sequence;
	countchange = inSrc.countchange;
	probmatrix3D = inSrc.probmatrix3D;
	countModelchange3D = inSrc.countModelchange3D;
	siteLallocatedFlag = 0;
	doScaling = inSrc.doScaling;
}
