/*
 *  macrodefine.h
 *  Originally created by Wanjun Gu for David Pollock's CLAMP/PLEX program
 *  Copyright (c) 2004 Dr. David Pollock. All rights reserved.
 
 PLEX - Phylogenetics, Likelihood, Evolution, and Complexity
 version 0.94 - beta version July, 2012
 
 Authors: A.P. Jason de Koning, Wanjun Gu and David Pollock
 jason.de.koning@gmail.com http://jasondk.org
 wanjungu@gmail.com
 David.Pollock@UCDenver.edu  http://www.evolutionarygenomics.com
 
 This program was created and distributed by the
 David Pollock laboratory, University of Colorado School of Medicine
 copyright © 2012 David Pollock
 All rights reserved.
 
 http://www.evolutionarygenomics.com
 Dept. Biochemistry & Molecular Genetics
 12801 17th Ave., MS 8101
 PO Box 6511
 Aurora, CO 80045
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * this file include all the global definition in PLEX
*/

#ifndef macrodefine_h__
#define macrodefine_h__

#define ENDSEQ '*'
#define NEWSEQ '>'
#define FNAMESIG '>'
#define PNAMESIG ';'
#define ELN 13
#define ELN2 '\n'
#define EOS '\0'
#define FASTA 0
#define PIR 1

#define MAXNAME 500		// maximum length of filename and sequence name
#define MAXLINE 150000		// maximum lenght of line in input file

// tree, align specific
#define MAXLENGTH 20000		// maximum length of sequence alignment
#define MAXSTATES 65		// maximum number of state in the model
#define MAXTAXA 100		// maximum number of taxa in the alignment

#define BLOCK 70		// number of characters in each line when print sequence 


extern const double cSmallDistance;
extern const double cInitDistance;
extern const char* CONTROLFILE;
extern const char* ENDWORD;
extern const char* cWhitespaceChars;

#endif // macrodefine_h__
